// TestMp410Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "TestMp410.h"
#include "TestMp410Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#pragma comment(lib,"MP410.lib")
#include "MP410.h"

HANDLE hDevice;


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMp410Dlg dialog

CTestMp410Dlg::CTestMp410Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestMp410Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestMp410Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestMp410Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestMp410Dlg)
	DDX_Control(pDX, IDC_LIST, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestMp410Dlg, CDialog)
	//{{AFX_MSG_MAP(CTestMp410Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_START, OnButtonStart)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_STOP, OnButtonStop)
	ON_BN_CLICKED(IDC_BUTTON_DO, OnButtonDo)
	ON_BN_CLICKED(IDC_BUTTON_DI, OnButtonDi)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestMp410Dlg message handlers

BOOL CTestMp410Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);

	m_List.InsertColumn( 0, "ͨ", LVCFMT_CENTER, 52, -1 );
	m_List.InsertColumn( 1, "ֵ", LVCFMT_CENTER, 65, -1 );
	m_List.InsertColumn( 2, "ѹֵ(V)", LVCFMT_CENTER, 72, -1 );

	//бʾͨ
	for(int i=0; i<=7; i++)
	{
		CString a;
		a.Format("  %d",i);
	    m_List.InsertItem(i,a);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTestMp410Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTestMp410Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestMp410Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

int CTestMp410Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	 
	hDevice=MP410_OpenDevice(0);

	if(hDevice==INVALID_HANDLE_VALUE)
	{
		AfxMessageBox("Error Open MP410, Please Check Driver or Hardware!");
		Beep(500,100);
		exit(0);
    }
	
	return 0;
}

void CTestMp410Dlg::OnButtonStart() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_BUTTON_START)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(TRUE);

	//бؼֵ
	for(int i=0; i<8; i++)
	{
		m_List.SetItemText(i, 1, "");
		m_List.SetItemText(i, 2, "");
	}

	MP410_AD_CAL(hDevice);

	Sleep(10);

	SetTimer(1, 100, NULL);//ʱAD
	
}

void CTestMp410Dlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
	if(nIDEvent==1)
	{
		char Buff1[8][100];
		char Buff2[8][100];
		long ADData;

		for(int ch=0;ch<=7;ch++)
		{
			ADData=MP410_AD(hDevice,ch,0,0,1);
			sprintf(Buff2[ch], "%d", ADData);//תֵͨ
			
			sprintf(Buff1[ch], "%5.3fV", ADData*5.0/4095.0);//ֵͨתΪѹֵ
			
			//бؼʾADֵѹֵ
			m_List.SetItemText(ch, 1, Buff2[ch]);
			m_List.SetItemText(ch, 2, Buff1[ch]);
		}
	}
}

void CTestMp410Dlg::OnButtonStop() 
{
	// TODO: Add your control notification handler code here
	GetDlgItem(IDC_BUTTON_START)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTON_STOP)->EnableWindow(FALSE);
	KillTimer(1);//ʱ
	
}

void CTestMp410Dlg::OnButtonDo() 
{
	// TODO: Add your control notification handler code here
	MP410_DO(hDevice,0x7f);

	CString IO_IN;
	long RDOData;

	RDOData=MP410_DO_Read(hDevice);
	
	IO_IN.Format("0x%x",RDOData);
	
	GetDlgItem(IDC_EDIT_DO)->SetWindowText(IO_IN);
	
}

void CTestMp410Dlg::OnButtonDi() 
{
	// TODO: Add your control notification handler code here
	
	CString IO_IN;
	long DIData,RDOData;

	//IO
	DIData=	MP410_DI(hDevice);

	//IOתΪʮݣ0x00xffffʾ
	IO_IN.Format("0x%x",DIData);
	
	GetDlgItem(IDC_EDIT_DI)->SetWindowText(IO_IN);


}
