unit Mp410u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button8: TButton;
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button8Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hd410:ulong; //


// 豸
//------------------------------------------------------------
Function MP410_OpenDevice(DeviceNum:ulong):ulong;stdcall; external 'MP410.dll';

Function MP410_CloseDevice (HANDLE :ulong):ulong;stdcall; external 'MP410.dll';

//***************************************************************************************
//AD

Function MP410_AD_CAL(HANDLE:ulong):ulong;stdcall; external 'MP410.dll';

Function MP410_AD (HANDLE,stch,gain,sidi,naver:ulong):ulong;stdcall; external 'MP410.dll';

//******************************************************************
//DIO FUNC

Function MP410_DO(hd,DO_data :ulong) :ulong;stdcall; external 'MP410.dll';

Function MP410_DI (hd:ulong) :ulong;stdcall; external 'MP410.dll';


Function MP410_DO_Read(hd:ulong) :ulong;stdcall; external 'MP410.dll';

//********************************************************************************

implementation

{$R *.dfm}

procedure TForm1.Button8Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
MP410_AD_CAL(hd410);
timer1.Enabled:=true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
m:longint;
n:real;
i:ulong;
tmp:string;
ADData:ulong;
begin
  memo1.Clear;
  for i:=0 to 6 do
  begin
  ADData:=MP410_AD(hd410,i,0,0,1);
  m:=ADData;
  n:=m *5.0 /4095.0;
  tmp:='CH' +inttostr(i)+'   ' +format('%4d',[m])+'   ' + format('%.3f',[n])+'V' ;
  memo1.Lines.Append(tmp);
  end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
hd410:= MP410_OpenDevice(0); //get handle
If hd410<> $ffffffff Then

    Form1.Caption:='MP410  Device Open OK!'

 else
 begin
    Form1.caption:='Device Open Eorror!';
    Beep;
    button1.Enabled:=false;
    button2.Enabled:=false;
    button3.Enabled:=false;
    button4.Enabled:=false;
    end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var
DO_Data:ulong;
begin
MP410_DO(hd410,$7f);
DO_Data:=MP410_DO_Read(hd410);
edit2.Text:=inttohex(DO_Data,2);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
DI_Data:ulong;
begin
DI_Data:= MP410_DI(hd410); //read DI
edit1.Text:=inttohex(DI_Data,2);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
timer1.Enabled :=false;
end;

end.
